#!/bin/env dls-python
import PandATest
from collections import OrderedDict


class Fmc(PandATest.PandATest):

    def test_code(self):

        #(cmd, (expected result, +/- tolerance of result))
        internal_commands = OrderedDict([
            ('FMC.FMC_PRSNT?',      ('OK =1',       0)),
            ('FMC.LOOP_PERIOD=125', ('OK',          0)),
            ('FMC.SOFT_RESET=',     ('OK',          0)),
            ('FMC.LA_P_ERROR?',     ('OK =0',       0)),
            ('FMC.LA_N_ERROR?',     ('OK =0',       0)),
            ('FMC.GTREFCLK?',       ('OK =10240',   1)),
            ('FMC.FMC_CLK0?',       ('OK =10240',   1)),
            ('FMC.FMC_CLK1?',       ('OK =10240',   1)),
            ('FMC.LINK_UP?',        ('OK =1',       0)),
        ])

        external_commands = OrderedDict([
            ('FMC.EXT_CLK?',       ('OK =0',        1)),
        ])

        for cmd, expected in internal_commands.items():
            response = self.send_cmd(cmd)
            self.test_result.append(
                self.check_response(response, expected[0], cmd, expected[1]))

        custom_freq = self.get_user_freq()

        for cmd, expected in external_commands.items():
            response = self.send_cmd(cmd)
            expected = 'OK =' + str(((8192 * 8) * custom_freq))
            self.test_result.append(
                self.check_response(response, expected, cmd, 1))

        return not all(self.test_result)

    def get_user_freq(self):
        user_prompt = "{} / {}".format(
            "External clock connected with 100Mhz? [return]",
            "enter custom freq in Mhz [<value>]")
        custom_freq = 100
        print user_prompt
        while True:
            try:
                custom_freq = int(raw_input() or 100)
                self.logger.info(
                    "{:<21}{}".format("EXTERN CLCK FREQ MHz", custom_freq))
                break
            except ValueError:
                print "Hit [return] for default of 100Mhz or enter a custom frequency"
        return custom_freq